
#ifndef |NAMEBIG|VIEW_H
#define |NAMEBIG|VIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for Qt
#include <qwidget.h>

class |NAME|Doc;

/** The |NAME|View class provides the view widget for the |NAME|App instance.	
 * The View instance inherits QWidget as a base class and represents the view object of a KTMainWindow. As |NAME|View is part of the
 * docuement-view model, it needs a reference to the document object connected with it by the |NAME|App class to manipulate and display
 * the document structure provided by the |NAME|Doc class.
 * 	
 * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team.
 * @version KDevelop version 0.4 code generation
 */
class |NAME|View : public QWidget
{
  Q_OBJECT
  public:
    /** Constructor for the main view */
    |NAME|View(QWidget *parent = 0, const char *name=0);
    /** Destructor for the main view */
    ~|NAME|View();

    /** returns a pointer to the document connected to the view instance. Mind that this method requires a |NAME|App instance as a parent
     * widget to get to the window document pointer by calling the |NAME|App::getDocument() method.
     *
     * @see |NAME|App#getDocument
     */
    |NAME|Doc *getDocument() const;

    /** contains the implementation for printing functionality */
    void print(QPrinter *pPrinter);
	
  private:
	
};

#endif // |NAMEBIG|VIEW_H
